/*
 * dmatrix.c
 */

#include "matrix.h"

dmatrix new_dmatrix(nrow, ncol)
int nrow, ncol;
{
    int i;
    dvector ap;
    dmatrix a;

    if ((a = (dmatrix)malloc(nrow * sizeof(dvector))) == NULL)
	    return NULL;
    if ((ap = (dvector)malloc(nrow * ncol * sizeof(double))) == NULL) {
	free(a);
	return NULL;
    }
    for (i = 0; i < nrow; i++)
        a[i] = ap + (i * ncol);
    return a;
}

void free_dmatrix(a)
dmatrix a;
{
    free(a[0]);
    free(a);
}
