/*
 * matrix.c
 */

#include "matrix.h"

matrix new_matrix(nrow, ncol)
int nrow, ncol;
{
    int i;
    vector ap;
    matrix a;

    if ((a = (matrix)malloc(nrow * sizeof(vector))) == NULL)
        return NULL;
    if ((ap = (vector)malloc(nrow * ncol * sizeof(scalar))) == NULL) {
        free(a);
        return NULL;
    }
    for (i = 0; i < nrow; i++)
        a[i] = ap + (i * ncol);
    return a;
}

void free_matrix(a)
matrix a;
{
    free(a[0]);
    free(a);
}
