/*
 * imatrix.c
 */

#include "matrix.h"

imatrix new_imatrix(nrow, ncol)
int nrow, ncol;
{
    int i;
    ivector ap;
    imatrix a;

    if ((a = (imatrix)malloc(nrow * sizeof(ivector))) == NULL)
	    return NULL;
    if ((ap = (ivector)malloc(nrow * ncol * sizeof(int))) == NULL) {
	free(a);
	return NULL;
    }
    for (i = 0; i < nrow; i++)
        a[i] = ap + (i * ncol);
    return a;
}

void free_imatrix(a)
imatrix a;
{
    free(a[0]);
    free(a);
}
